Java/Java开发框架 数据库相关教程 大数据相关教程 HTML/CSS相关教程 JavaScript/前端框架 开发工具相关教程 后端开发相关教程 Java开发技术 Java面试题库 Java架构设计 大数据资讯 大数据技术 大数据应用 Python开发技术 HTML HTML5 CSS JavaScript jQuery Vue AngularJS MySQL Oracle SQLServer MongoDB Redis

java的异常与处理机制分析【附面试题】

发布时间:2020-05-20 11:03:46  作者:本站编辑  来源:本站原创  浏览次数:

摘要:这篇Java面试题库栏目下的“java的异常与处理机制分析【附面试题】”,介绍的技术点是“处理机制、Java、面试题、面试、分析、异常”,希望对大家开发技术学习和问题解决有帮助。

本文实例讲述了java的异常与处理机制。分享给大家供大家参考,具体如下:

java的异常机制

Throwable类

Throwable类是Java异常类型的顶层父类,一个对象只有是 Throwable 类的(直接或者间接)实例,他才是一个异常对象,才能被异常处理机制识别。JDK中内建了一些常用的异常类,我们也可以自定义异常。

Throwable又派生出Error类和Exception类。

错误:Error类以及他的子类的实例,代表了JVM本身的错误。错误不能被程序员通过代码处理,Error很少出现。因此,程序员应该关注Exception为父类的分支下的各种异常类。

异常:Exception以及他的子类,代表程序运行时发送的各种不期望发生的事件。可以被Java异常处理机制使用,是异常处理的核心。

java异常体系结构

Java中的异常分为两大类(根据javac对异常的处理要求):

Checked exception(受检异常):除了Error 和 RuntimeException的其它异常。受检异常表示程序本身没有问题,但由于I/O、网络、数据库等其他不可预测的错误导致的异常,也可能是因为资源耗尽导致的异常。javac强制要求程序员为这样的异常做预备处理工作(使用try…catch…finally或者throws)。在方法中要么用try-catch语句捕获它并处理,要么用throws子句声明抛出它,否则编译不会通过。这样的异常一般是由程序的运行环境导致的。因为程序可能被运行在各种未知的环境下,而程序员无法干预用户如何使用他编写的程序,于是程序员就应该为这样的异常时刻准备着。如SQLException , IOException,ClassNotFoundException 等。

Unchecked exception(Runtime Exception)(未受检异常):Error 和 RuntimeException 以及他们的子类。未受检异常一般认为是代码的逻辑问题,一般需要修改代码来解决异常,也可以使用异常机制处理。这样的异常发生的原因多半是代码写的有问题。如除0错误ArithmeticException,错误的强制类型转换错误ClassCastException,数组索引越界ArrayIndexOutOfBoundsException,使用了空对象NullPointerException等等。

Runtime Exception类直接继承自Exception类,Java中所有的运行时异常都会直接或间接地继承自Runtime Exception

Java中凡是继承自Exception,而不是继承自Runtime Exception类的异常都是Checked Exception

异常处理的基本语法

在编写代码处理异常时,对于检查异常,有2种不同的处理方式:使用try…catch…finally语句块处理它。或者,在函数签名中使用throws 声明交给函数调用者caller去解决。

(1)try…catch…finally语句块

try{
   //try块中放可能发生异常的代码。
   //如果执行完try且不发生异常,则接着去执行finally块和finally后面的代码(如果有的话)。
   //如果发生异常,则尝试去匹配catch块。
}catch(SQLException SQLexception){
  //每一个catch块用于捕获并处理一个特定的异常,或者这异常类型的子类。Java7中可以将多个异常声明在一个catch中。
  //catch后面的括号定义了异常类型和异常参数。如果异常与之匹配且是最先匹配到的,则虚拟机将使用这个catch块来处理异常。
  //在catch块中可以使用这个块的异常参数来获取异常的相关信息。异常参数是这个catch块中的局部变量,其它块不能访问。
  //如果当前try块中发生的异常在后续的所有catch中都没捕获到,则先去执行finally,然后到这个函数的外部caller中去匹配异常处理器。
  //如果try中没有发生异常,则所有的catch块将被忽略。
}catch(Exception exception){
  //...
}finally{
  //finally块通常是可选的。
  //无论异常是否发生,异常是否匹配被处理,finally都会执行。
  //一个try至少要有一个catch块,否则, 至少要有1个finally块。但是finally不是用来处理异常的,finally不会捕获异常。
//如果在try或者catch语句中存在return语句,则return语句会在finally语句执行结束后执行,但是finally并不能改变返回值。
//如果在finally语句中也有return,那么try和catch中的return语句会丢失,实际会返回finally中的返回值。
 //finally主要做一些清理工作,如流的关闭,数据库连接的关闭等。
}

注意点:

try块中的局部变量和catch块中的局部变量(包括异常变量),以及finally中的局部变量,他们之间不可共享使用。

每一个catch块用于处理一个异常。异常匹配是按照catch块的顺序从上往下寻找的,只有第一个匹配的catch会得到执行。匹配时,不仅运行精确匹配,也支持父类匹配,因此,如果同一个try块下的多个catch异常类型有父子关系,应该将子类异常放在前面,父类异常放在后面,这样保证每个catch块都有存在的意义。

finally块不管异常是否发生,只要对应的try执行了,则它一定也执行。只有一种方法让finally块不执行:System.exit()。因此finally块通常用来做资源释放操作:关闭文件,关闭数据库连接等等。良好的编程习惯是:在try块中打开资源,在finally块中清理释放这些资源。

finally块没有处理异常的能力。处理异常的只能是catch块。

在同一try…catch…finally块中 ,如果try中抛出异常,且有匹配的catch块,则先执行catch块,再执行finally块。如果没有catch块匹配,则先执行finally,然后去外面的调用者中寻找合适的catch块。

在同一try…catch…finally块中 ,try发生异常,且匹配的catch块中处理异常时也抛出异常,那么后面的finally也会执行:首先执行finally块,然后去外围调用者中寻找合适的catch块。

(2)throws 函数声明

throws声明:如果一个方法内部的代码会抛出检查异常(checked exception),而方法自己又没有完全处理掉,则javac保证你必须在方法的签名上使用throws关键字声明这些可能抛出的异常,否则编译不通过。

throws是另一种处理异常的方式,它不同于try…catch…finally,throws仅仅是将函数中可能出现的异常向调用者声明,而自己则不具体处理。

采取这种异常处理的原因可能是:方法本身不知道如何处理这样的异常,或者说让调用者处理更好,调用者需要为可能发生的异常负责。

public void foo() throws ExceptionType1 , ExceptionType2 ,ExceptionTypeN
{
   //foo内部可以抛出 ExceptionType1 , ExceptionType2 ,ExceptionTypeN 类的异常,或者他们的子类的异常对象。
}

throw 异常抛出语句

语法 : throw exceptionObject

程序员也可以通过throw语句手动显式的抛出一个异常。throw语句的后面必须是一个异常对象。

在某个方法(如:a方法)中,使用throw new 异常,的方式抛出异常异常,即本方法不会对异常进行处理,而是由调用a 的方法b来处理(此时b会使用throws关键字抛出),如果b也被方法c调用,那么c来处理,逐层类推,直到main方法,如果main方法也是选择抛出异常,那么就叫交给JVM处理

throw 语句必须写在函数中,执行throw 语句的地方就是一个异常抛出点,它和由JRE自动形成的异常抛出点没有任何差别。

package practice;
public class ExceptionTest {
    public static void test(Object obj) {
        try {
            if (obj == null) {
                throw new Exception();// 此处抛出的异常,在catch中被处理了
            }
        } catch (Exception e) {
            System.out.println("nullpoint");
        }
    }
    public static void test2(Object obj) throws Exception {
        try {
            obj.toString();
        } catch (Exception e) {
            throw new Exception();//在catch块中抛出新的异常,构成了异常链,这是因为原来的异常对象e可能不能处理这个异常,需要另一个异常对象来处理该异常
        }
    }
    public static void test1(Object obj) throws Exception {
        if (obj == null) {
            throw new Exception();// 此处抛出的异常,通过throws的方式,由调用test的方法处理
        }
    }
    public static void main(String[] args) throws Exception{
        ExceptionTest.test(null);
        //处理抛出异常的两种方式
        //方式一:test2函数使用throws抛出了异常,所以得接住这个异常,并处理
        try {
            ExceptionTest.test2(null);
        }catch(Exception e) {
            System.out.println("nullpoint");
        }
        //方式二:test1抛出的异常使用Throws的方式处理
        ExceptionTest.test1(null);
    }
}

自定义异常

自定义异常:通常就是定义了一个继承自Exception类的子类,那么这个类就是一个自定义异常类。通常情况下,我们都会直接继承自Exception类,一般不会继承某个运行时的异常类

异常的特性:

一个try可以有多个catch块,但运行时只有一个catch块可以被执行,并且是按照顺序来寻找匹配的catch块的,所以需要将父类的异常需要放在后面的catch块中

try{
test.method(str);
}catch (MyException e)
{
System.out.println("MyException catch");
e.printStackTrace();
}catch(MyException2 e)
{
System.out.println("MyException2 catch");
e.printStackTrace();
}catch(Exception e)
{
System.out.println(“Exception catch”);
e.printStackTrace();
}
finally
{System.out.println("finally");
}

try{
test.method(str);
}catch(Exception e)
{
System.out.println(“Exception catch”);
e.printStackTrace();
}
catch (MyException e)
{
System.out.println("MyException catch");
e.printStackTrace();
}catch(MyException2 e)
{
System.out.println("MyException2 catch");
e.printStackTrace();
}
finally
{System.out.println("finally");
}

面试题目

题目一:

package defineexception;
public class ExceptionTest3
{
    public void method()
    {
        try
        {
            System.out.println("try");
            return;
        }
        catch(Exception ex)
        {
            System.out.println("异常发生了");
        }
        finally
        {
            System.out.println("finally");
        }
        System.out.println("异常处理后续的代码");
    }
    public static void main(String[] args)
    {
        ExceptionTest3 test =new ExceptionTest3();
        test.method();
    }
}

结果:

try
finally

分析

try块中存在return语句,那么首先也需要将finally块中的代码执行完毕,再执行return语句,而且之后的其他代码也不会再执行了

题目二:

package defineexception;
public class ExceptionTest3
{
    public void method()
    {
        try
        {
            System.out.println("try");
            System.exit(0);
        }
        catch(Exception ex)
        {
            System.out.println("异常发生了");
        }
        finally
        {
            System.out.println("finally");
        }
        System.out.println("异常处理后续的代码");
    }
    public static void main(String[] args)
    {
        ExceptionTest3 test =new ExceptionTest3();
        test.method();
    }
}

结果

try

分析

先执行try块中的System.exit(0)语句,已经退出了虚拟机系统,所以不会执行finally块的代码

参考链接

https://www.jb51.net/article/161574.htm

更多java相关内容感兴趣的读者可查看本站专题:《Java面向对象程序设计入门与进阶教程》、《Java数据结构与算法教程》、《Java操作DOM节点技巧总结》、《Java文件与目录操作技巧汇总》和《Java缓存操作技巧汇总

希望本文所述对大家java程序设计有所帮助。

文章关键词: Java 处理机制 面试题 异常 分析 面试

  • 0

    开心

  • 0

    板砖

  • 0

    感动

  • 0

    有用

  • 0

    疑问

  • 0

    难过

  • 0

    无聊

  • 0

    震惊

评论已有 0

登录之后才能发表评论

相关文章

加载更多